/*************************************************************************
 *************************************************************************
 **									**
 **	 		Copyright (c) 1994, 1995 			**
 **	    Brown University Institute for Medical Computing		**
 **	      and the American College of Cardiology (ACC)		**
 **									**
 ** The software and support documentation for the American College of	**
 ** Cardiology's 1995 demonstration of DICOM interchange media were	**
 ** developed at the Brown University Institute for Medical Computing.	**
 **									** 
 ** THIS SOFTWARE IS MADE AVAILABLE "AS IS", AND NEITHER THE AMERICAN	**
 ** COLLEGE OF CARDIOLOGY (ACC) NOR BROWN UNIVERSITY MAKE ANY WARRANTY	**
 ** ABOUT THE SOFTWARE, ITS PERFORMANCE, ITS MERCHANTABILITY OR FITNESS	**
 ** FOR ANY PARTICULAR USE, FREEDOM FROM DEFECTS, OR ITS CONFORMANCE TO	**
 ** ANY SPECIFICATION.  THE ENTIRE RISK AS TO QUALITY AND PERFORMANCE	**
 ** OF THE SOFTWARE IS WITH THE USER.					**
 **									** 
 ** Copyright of the software and supporting documentation is jointly	**
 ** owned by the ACC and Brown University, and free access is hereby	**
 ** granted as a license to use this software, copy this software and	**
 ** prepare derivative works based upon this software.  However, any	**
 ** distribution of the source code or executable versions of this	**
 ** software, or of the	 supporting documentation (or of derivative	**
 ** works of the software or supporting documentation) must include	**
 ** this copyright notice and explanation.				**
 **									** 
 ** Author: Jonathan L. Elion MD, FACC					**
 **									**
 ************************************************************************* 
 *************************************************************************/ 


#define MAX_DEPTH 10

typedef struct patientData {
    char fileID[VR_CS_LENGTH + 1];
    char SOP_ClassUID[VR_UI_LENGTH + 1];
    char SOP_InstanceUID[VR_UI_LENGTH + 1];
    char patientName[VR_UI_LENGTH + 1];
    char patientID[VR_UI_LENGTH + 1];
}patientDataName; 

typedef struct studyData {
    char fileID[VR_CS_LENGTH + 1];
    char SOP_ClassUID[VR_UI_LENGTH + 1];
    char SOP_InstanceUID[VR_UI_LENGTH + 1];
    char studyDate[VR_DA_LENGTH + 1];
    char studyTime[VR_TM_LENGTH + 1];
    char studyDescription[VR_LO_LENGTH + 1];
}studyDataName;

typedef struct seriesData {
    char fileID[VR_CS_LENGTH + 1];
    char SOP_ClassUID[VR_UI_LENGTH + 1];
    char SOP_InstanceUID[VR_UI_LENGTH + 1];
    char modality[VR_CS_LENGTH + 1];
    char institutionName[VR_LO_LENGTH + 1];
    char institutionAddress[VR_ST_LENGTH + 1];
    char seriesInstanceUID[VR_UI_LENGTH + 1];
    char seriesNumber[VR_IS_LENGTH + 1];
    char performingMD[VR_PN_LENGTH + 1];
}seriesDataName;

typedef struct imageData {
    char fileID[VR_CS_LENGTH + 1];
    char SOP_ClassUID[VR_UI_LENGTH + 1];
    char SOP_InstanceUID[VR_UI_LENGTH + 1];
    char imageNumber[VR_IS_LENGTH + 1];
    char calibrationObject[VR_CS_LENGTH + 1];
#ifndef __MSDOS__
    unsigned char icon[128][128];
#endif
}imageDataName;

/*
 * This dirRecord structure holds the "normalized" data for an image
 * (in this case a multi-frame image).  Normalized data does not rely
 * on a hierarchy of objects, and has essentially been "flattened" so
 * that all of the pertinent information is contained in a single
 * structure.  This is expensive in terms of storage requirements,
 * as information gets repeated (for example, patient name gets stored
 * for each image in a series).  The great advantage is that access to
 * the information is greatly simplified.  Within this dirRecord
 * structure, information derived from patient, study, series, and
 * image directory records is segregated, simplifying the process of
 * "flattening" the data into its normalized format.
 */

typedef struct dirRecord {
    struct dirRecord *nextRecord;
    struct patientData patientInfo;
    struct studyData studyInfo;
    struct seriesData seriesInfo;
    struct imageData imageInfo;
}dirRecordName;

void decompFrame(void);
